
#ifndef __AIDGE_GREGEX_TOKEN_TYPES_H__
#define __AIDGE_GREGEX_TOKEN_TYPES_H__


namespace Aidge {
    /**
     * @brief enum for all types of token use in the of the regex 
     * 7-5 type
     * 4-0 id
    */
    enum class gRegexTokenTypes
    {
        NEXT                = (1 << 4)+1, /**< -> */ 

        QOM                 = (1 << 5)+1, /**< + */ 
        QZM                 = (1 << 5)+2, /**< * */ 

        KEY                 = (1 << 6)+2, /**< [A-Za-z_0-9]+ */ 
        CKEY                = (1 << 6)+1, /**< [A-Za-z_0-9]+#[0-9]* */ 
        
        SEP                 = (1<<7) +1, /**< \( */
        LPAREN              = (1<<7) +2, /**< \( */
        RPAREN              = (1<<7) +3, /**< \) */
        STOP                = 0,
    };

}
#endif //__AIDGE_GREGEX_TOKEN_TYPES_H__