

#ifndef _AIDGE_CONDITIONAL_TYPES_H_
#define _AIDGE_CONDITIONAL_TYPES_H_
namespace Aidge{
    /**
     * @brief enum for all types of token use in the parsing 
     * 7-5 type
     * 4-0 id
    */
    enum class ConditionalTokenTypes
    {
        NOT                 = (1 << 4)+3, /**< ! */ 
        AND                 = (1 << 4)+2, /**< && */ 
        OR                  = (1 << 4)+1, /**< || */ 

        EQ                  = (1 << 5)+1, /**< == */ 
        NEQ                 = (1 << 5)+2, /**< != */ 

        KEY                 = (1 << 6) +1 , /**< [A-Za-z][A-Za-z0-9_]* */
        INTEGER             = (1 << 6) +2 , /**< [0-9]+ */
        FLOAT               = (1 << 6) +3 , /**< [0-9]+\.[0-9]* */
        STRING              = (1 << 6) +4 , /**< \'.*\' */
        BOOL                = (1 << 6) +5 , /**< true|false */
        NODE                = (1 << 6) +6 , /**< \$ */
        LAMBDA              = (1 << 6) +7 , /**< [A-Za-z][A-Za-z0-9_]*\( */

        ARGSEP              = (1<<7) +1, /**< , */
        LPAREN              = (1<<7) +2, /**< \( */
        RPAREN              = (1<<7) +3, /**< \) */
        STOP                = 0,
    };
}
#endif